function [x]= alg36_sis_tridiag(d,l,u,b)
% Efolio-B - Andreia Romao 1702430
% Algoritmo 3.6 (do manual) - Metodo de Gauss - Sistemas Tridiagonais

n=size(d,2);
x=zeros(n,1);

for k=1:n-1
  m=l(k+1)/d(k);
  % transformar em triangular superior
  % eliminar a linha que tem o elemento l(k+1)
  d(k+1)=d(k+1)-m*u(k); % mexe no elemento d(k+1)
  b(k+1)=b(k+1)-m*b(k); % mexe no elemento b(k+1)
end

% obter a solução de x(n)
x(n)=b(n)/d(n);

% resolver por substituição inversa Ux=y, B=[U y]
for k=n-1:-1:1
  x(k)=(b(k)-(u(k)*x(k+1)))/d(k);
end
% EOF

